///////////////////////////////////////////////////////////////////Section 1///////////////////////////////////////////////////////////////////////////

#include <VarSpeedServo.h> //Go to https://github.com/netlabtoolkit/VarSpeedServo and download the VarSpeedServo library by clicking the green button "Clone or download" and then "Download ZIP".

//Servo's names and pins

VarSpeedServo RLeg; //Right Leg attached on pin 2
VarSpeedServo LLeg; //Left Leg attached on pin 3
VarSpeedServo RFang; //Right Fang attached on pin 4
VarSpeedServo LFang; //Left Fang attached on pin 5
VarSpeedServo RuEye; //Right Up Eye attached on pin 6
VarSpeedServo LuEye; //Left Up Eye attached on pin 7
VarSpeedServo RdEye; //Right Down Eye attached on pin 8
VarSpeedServo LdEye; //Left Down Eye attached on pin 15





// LED's names & pins
int RedLed = 9;
int BlueLed = 16;
int YellowLed = 10;

//Motion Sensor name and pin
int PIR = A3; 


long ProgramStby; //Stores random number for Stby Mode
long ProgramTrigger; //Stores random number for Trigger Mode


///////////////////////////////////////////////////////////////////Section 2///////////////////////////////////////////////////////////////////////////
void setup() {

 // initialize serial
  Serial.begin(9600);

 //LED's pin mode
 pinMode(RedLed, OUTPUT);
 pinMode(BlueLed, OUTPUT);
 pinMode(YellowLed, OUTPUT);

 //Motion Sensor pin mode
 pinMode(PIR, INPUT);
 
} 

///////////////////////////////////////////////////////////////////Section 3/////////////////////////////////////////////////////////////////////////// 
void loop() {

for (int timer = 0; (timer <= 1500 && digitalRead(PIR) == LOW); timer += 1) //Interval and Check for Motion  (1500 = 5 minutes)


{
delay(200);   //do not change   
}


//Checking for motion active alarm
if (digitalRead(PIR) == HIGH)
{
  Trigger();
}

//No motion alarm found, going to random Stby mode.
else
{
Stby();  
}

}

///////////////////////////////////////////////////////////////////Section 4///////////////////////////////////////////////////////////////////////////
void Trigger()
{
ProgramTrigger = random(1,4);

//-----------------------Triggered program #1-------------------------//
if (ProgramTrigger == 1)
{
  //Program #1

  //Attaching & Opens both Fangs servos
  LFang.attach(5);
  RFang.attach(4);  
  LFang.write(25,100,false);
  RFang.write(145,100,false);


  //Police effect
  int times = 0;
  while (times < 10)
  {
 digitalWrite(RedLed, true);
 digitalWrite(BlueLed, false);
 delay(100);
 digitalWrite(RedLed, false);
 digitalWrite(BlueLed, true);
 delay(100);
 times++;
 }
 digitalWrite(BlueLed, false);
 digitalWrite(RedLed, false);
  

//Attaching servos
  LLeg.attach(2);
  RLeg.attach(3);
  LuEye.attach(7);
  RuEye.attach(6);
  LdEye.attach(15);
  RdEye.attach(8);

     //Moves Legs
     RLeg.write(140,70,true);
     LLeg.write(60,100,false);
     RLeg.write(65,70,true);

       //Moving eyes in random position & Blinks Red,Blue LED
       for (int timer = 0; timer <= 40; timer += 1)
    {
     digitalWrite(RedLed, true);
     digitalWrite(BlueLed, false);
     LuEye.write(random(30, 160),160,false);
     RuEye.write(random(30, 160),150,true); 
     digitalWrite(RedLed, false);
     digitalWrite(BlueLed, true);
     LdEye.write(random(30, 160),170,false);
     RdEye.write(random(30, 160),160,true); 
     digitalWrite(RedLed, false);
     digitalWrite(BlueLed, true);
     delay(100);
     digitalWrite(RedLed, true);
     digitalWrite(BlueLed, false);
    }
     digitalWrite(RedLed, false);
     digitalWrite(BlueLed, false);

    //Closes Fangs & Calls flame effect
    LFang.write(140,30,false);
    RFang.write(40,25,false);
    flame_effect();
   
}

// Triggered Program #1 End ////////////////////////////////////////////////////////////


// Triggered Program #2 Start ////////////////////////////////////////////////////////// 
if (ProgramTrigger == 2)
{
  //Program #2

  //Attaching and moves the fangs
  LFang.attach(5);
  RFang.attach(4);  
  LFang.write(25,40,false);
  RFang.write(145,35,true);
  delay(500);
  
for (int timer = 0; timer <= 3; timer += 1) 
    {
LFang.write(160,230,false);
delay(250);
RFang.write(50,230,true);
LFang.write(25,230,false);
RFang.write(145,200,true);
delay(100);  
}  


  //Police effect
  int times = 0;
  while (times < 10)
  {
 digitalWrite(RedLed, true);
 digitalWrite(BlueLed, false);
 delay(100);
 digitalWrite(RedLed, false);
 digitalWrite(BlueLed, true);
 delay(100);
 times++;
 }
 digitalWrite(BlueLed, false);
 digitalWrite(RedLed, false);
  

//Attaching and moves eye servos in random position
  LuEye.attach(7);
  RuEye.attach(6);
  LdEye.attach(15);
  RdEye.attach(8);

            
       for (int timer = 0; timer <= 10; timer += 1)
    {
     digitalWrite(RedLed, true);
     LuEye.write(random(30, 160),160,false);
     RuEye.write(random(30, 160),150,true); 
     LdEye.write(random(30, 160),60,true);
     RdEye.write(random(30, 160),60,true); 
     digitalWrite(RedLed, false);
     delay(100);     
    }
    
    //Attaching and moves legs
    LLeg.attach(3);
    RLeg.attach(2);

RLeg.write(140,70,true);
LLeg.write(60,100,false);
RLeg.write(65,70,true);    
        
}

// Triggered Program #2 End ////////////////////////////////////////////////////////////////

// Triggered Program #3 Start //////////////////////////////////////////////////////////////
if (ProgramTrigger == 3)
{
LLeg.attach(3);
RLeg.attach(2);
LuEye.attach(7);
RuEye.attach(6);
LdEye.attach(15);
RdEye.attach(8);

   for (int timer = 0; timer <= 3; timer += 1)
    {
      
RLeg.write(random(65,140),70,true);
LLeg.write(random(65,140),100,true);
RLeg.write(random(65,140),70,true);  

for (int timer = 0; timer <= 1; timer += 1)
    {
  LuEye.write(90,200,false);
  RdEye.write(90,200,true);
  RuEye.write(90,200,true);
  LdEye.write(90,200,true);
  LuEye.write(140,200,false);
  RdEye.write(25,200,true);
  RuEye.write(160,200,true);
  LdEye.write(35,200,true);
  
    }
  
    }
       
    for (int timer = 0; timer <= 5; timer += 1)
    {
     LuEye.write(random(30, 160),30,true);
     RuEye.write(random(30, 160),30,true); 
     LdEye.write(random(40, 140),30,false);
     RdEye.write(random(40, 140),30,false);
    }
 
  
}

// Triggered Program #3 End /////////////////////////////////////////////////////////////////////////


// Triggered Program #4 Start /////////////////////////////////////////////////////////////////////////
if (ProgramTrigger == 4)
{
  LuEye.attach(7);
  RuEye.attach(6);
  LdEye.attach(15);
  RdEye.attach(8);
  
     LuEye.write(random(30, 160),30,true);
     RuEye.write(random(30, 160),30,true); 
     LdEye.write(random(40, 140),30,false);
     RdEye.write(random(40, 140),30,false); 
}
// Triggered Program #4 End /////////////////////////////////////////////////////////////////////////
    
ResetPos(); //End of Triggered functions, going to Section 8

}


///////////////////////////////////////////////////////////////////Section 5///////////////////////////////////////////////////////////////////////////
 void Stby()
 
{
ProgramStby = random(5);
//---------------------//Program #0----------------------//
if (ProgramStby == 0)  
{  
LLeg.attach(3);
RLeg.attach(2);

RLeg.write(140,70,true);
LLeg.write(60,100,false);
RLeg.write(65,70,true);    
}  
//-------------------------------------------------------//    
  
//---------------------//Program #1----------------------//
if (ProgramStby == 1)   
{  
  LFang.attach(5);
  RFang.attach(4);  
  LFang.write(25,13,false);
  RFang.write(145,10,true);
  delay(500);
for (int timer = 0; timer <= 1; timer += 1)
    {
LFang.write(160,230,false);
delay(250);
RFang.write(50,230,true);
LFang.write(25,230,false);
RFang.write(145,200,true);
delay(100);  
}  
}
//-------------------------------------------------------//

//---------------------//Program #2----------------------//
if (ProgramStby == 2) 
{
  LuEye.attach(7);
  RuEye.attach(6);
  LdEye.attach(15);
  RdEye.attach(8);

    for (int timer = 0; timer <= 5; timer += 1)
    {
     LuEye.write(random(30, 160),30,true);
     RuEye.write(random(30, 160),30,true); 
     LdEye.write(random(40, 140),30,false);
     RdEye.write(random(40, 140),30,false);
    }
}
//-------------------------------------------------------//

//---------------------//Program #3----------------------//
if (ProgramStby == 3)
{
  LdEye.attach(15);
  RdEye.attach(8);
  LFang.attach(5);
  RFang.attach(4);
  
     LdEye.write(90,30,false);
     RdEye.write(90,15,true); 
     LdEye.write(160,30,false);
     RdEye.write(160,30,true); 
     LdEye.write(20,30,false);
     RdEye.write(20,30,true); 
     delay(500);
     LFang.write(90,90,false);
     RFang.write(90,85,true);
}
//-------------------------------------------------------//

//---------------------//Program #4----------------------//
if (ProgramStby == 4)
{
for (int timer = 0; timer <= 3; timer += 1)
{
  LuEye.attach(7);
  RuEye.attach(6);
  LuEye.write(70,200,false);
  RuEye.write(70,200,true);
  LuEye.write(120,200,false);
  RuEye.write(120,200,true);
}
}
//-------------------------------------------------------//

//---------------------//Program #5----------------------//
if (ProgramStby == 5) //Program #5
{
  flame_effect();
     
}
//-------------------------------------------------------//

ResetPos(); //End of Stby functions, going to Section 8
}



///////////////////////////////////////////////////////////////////Section 6///////////////////////////////////////////////////////////////////////////
void flame_effect() // For LED's
{
  int times = 0;
  while (times < 500)
  {
 analogWrite(RedLed, random(100));
 analogWrite(YellowLed, random(255));
 delay(10);
 times++;
 }
 analogWrite(RedLed, 0);
 analogWrite(YellowLed, 0);
}


///////////////////////////////////////////////////////////////////Section 7///////////////////////////////////////////////////////////////////////////
void police_effect() //For LED's
{
  int times = 0;
  while (times < 20)
  {
 digitalWrite(RedLed, true);
 digitalWrite(BlueLed, false);
 delay(100);
 digitalWrite(RedLed, false);
 digitalWrite(BlueLed, true);
 delay(100);
 times++;
 }
 digitalWrite(BlueLed, false);
 digitalWrite(RedLed, false);
}


///////////////////////////////////////////////////////////////////Section 8///////////////////////////////////////////////////////////////////////////
void ResetPos() //Set all servos to rest position & detach for power saving
{
 LLeg.attach(3);
 RLeg.attach(2);
 LuEye.attach(7);
 RuEye.attach(6);
 LdEye.attach(15);
 RdEye.attach(8);
 LFang.attach(5);
 RFang.attach(4);
 Serial.println("Rest");
 LLeg.write(140,35,true); 
 RLeg.write(60,35,true);
 LuEye.write(20,170,false);
 RuEye.write(20,170,true);
 LdEye.write(50,70,false);
 RdEye.write(140,70,true);
 LFang.write(140,70,false);
 RFang.write(40,70,true);
 delay(100);
 LLeg.detach(); 
 RLeg.detach();
 LuEye.detach();
 RuEye.detach();
 LdEye.detach();
 RdEye.detach();
 LFang.detach();
 RFang.detach();

 
 loop(); //Going back to loop
}
